LeetCode解题报告 377. Combination Sum IV [medium]

题目描述

Given an integer array with all positive numbers and no duplicates, find the number of possible combinations that add up to a positive integer target.

Example:

nums = [1, 2, 3]
target = 4

The possible combination ways are:
(1, 1, 1, 1)
(1, 1, 2)
(1, 2, 1)
(1, 3)
(2, 1, 1)
(2, 2)
(3, 1)

Note that different sequences are counted as different combinations.

Therefore the output is 7.

解题思路

类似完全背包问题(可重复背包)

f[0]=1

f[i] 组成和为i的方案数

f[i]=求和(f[i-nums[j])

(对于示例中的数值:

   最后一个为1时,求有多少个组成和为4-1=3的方案数;

   最后一个为2时,求有多少个组成和为4-2=2的方案数;

   最后一个为3时,求有多少个组成和为4-3=1的方案数;

   即f[4]=f[4-1]+f[4-2]+f[4-3]=f[3]+f[2]+f[1]

return f[target]


target依次从1,2,3,4变化。


时间复杂度

O(target)*O(nums.size() ),即O(n*n)

代码如下:

class Solution {
public:
    int combinationSum4(vector& nums, int target) {
        if(nums.empty()) return 0;
        sort(nums.begin(),nums.end());
        vector dp(target+1,0);
        for(int i = 1; i <= target; i++){
            int count = 0;
            for(int j = 0; j < nums.size(); j++){
                if(i < nums[j]) break;
                if(i == nums[j]) count++;
                else count += dp[i-nums[j]];
            }
            dp[i] = count;
        }
        /*for (int i=0; i


你可能感兴趣的:(leetcode)